#include<fstream>
#include<iostream>
#include<sstream>
#include<cstdio>
#include<cstdlib>
using namespace std;
#include "nbody.h"


// this file contains readin stuff 

/* routines:
sread:      read in initial conditions file
*/

// void sread(char *parmfile,  SIMinfo *siminfo);
//extern "C" { }


// read in the simulations input structure from a parameter file
#define SLEN 256
void sread(char *parmfile,  SIMinfo *siminfo)
{
  ifstream filestr;
  char pline[SLEN];
  istringstream iss;
  filestr.open(parmfile, fstream::in);

  if (!filestr.is_open()) {
    printf("sread: %s file not found\n",parmfile);
    exit(0);
  }


  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->outroot;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->numBodies;
//  cout << siminfo->numBodies << endl;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->numBodiesMassive;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->device;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->deltaTime;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->niter;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->ndt;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->damping;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->soft2_int;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->soft2_her;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->hillfac_int;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->hillfac_col;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->amin;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->amax;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->gamma;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->ibar;

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->m;
  
  double flag;
  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> flag;  // not yet used
  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> flag;  // not yet used
  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> flag;  // not yet used
  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> flag;  // not yet used

  filestr.getline(pline,SLEN);
  iss.str(pline);
  iss >> siminfo->nplanets;

  for(int j=0;j<siminfo->nplanets;j++){
    double a,e,ii,longnode,argperi,meananom;
    filestr.getline(pline,SLEN);
    iss.str(pline);
    iss >> siminfo->mplanets[j] 
        >> a >> e >> ii >> longnode >> argperi >> meananom;  
//    cout << siminfo->mplanets[j]<< "," << a << "," << e << "," << ii << endl;
//    cout <<  longnode << "," << argperi << "," << meananom << endl;
    siminfo->orbel[j].a=a;
    siminfo->orbel[j].e=e;
    siminfo->orbel[j].i=ii;
    siminfo->orbel[j].longnode=longnode;
    siminfo->orbel[j].argperi=argperi;
    siminfo->orbel[j].meananom=meananom;
  }
  
//  cout << siminfo->numBodies << endl;


  filestr.close();

}
     




